package org.ow2.orchestra.designer.commands {
  import com.adobe.cairngorm.business.ServiceLocator;
  import com.adobe.cairngorm.commands.ICommand;
  import com.adobe.cairngorm.control.CairngormEvent;

  import mx.collections.ArrayCollection;
  import mx.collections.ListCollectionView;
  import mx.rpc.AsyncToken;
  import mx.rpc.Responder;
  import mx.rpc.events.FaultEvent;
  import mx.rpc.events.ResultEvent;
  import mx.rpc.remoting.RemoteObject;

  import org.ow2.orchestra.designer.model.DesignerModelLocator;
  import org.ow2.orchestra.designer.utils.ErrorManager;

  /**
   * Initialize the files list into the FileNavigatorView
   */
  public class WsdlNavigatorFetchModelCMD implements ICommand {

    public function WsdlNavigatorFetchModelCMD() {
    }

    /**
     *
     * @param event
     *
     */
    public function execute(event:CairngormEvent):void {

      var remote:RemoteObject = ServiceLocator.getInstance().getRemoteObject("wsdlNavigator");
      var token:AsyncToken = remote.getAvailableServices();

      // add listener for the asyn response of remote object and change the cursor to busy
      token.addResponder(new Responder(getResult, fault));
    }

    private function fault(event:FaultEvent):void {
      ErrorManager.getInstance().showError("Problem during initialization of OrchestraDesigner : " + event.message);
    }

    private function getResult(event:ResultEvent):void {
      var availableServices:ArrayCollection = DesignerModelLocator.getInstance().availableServices;

      var services:ListCollectionView = event.result as ListCollectionView;

      availableServices.removeAll();
      availableServices.addAll(services);
    }

  }
}
