/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import com.adobe.cairngorm.control.CairngormEvent;

import mx.collections.ArrayCollection;

import mx.collections.ListCollectionView;

import org.ow2.orchestra.designer.vo.FileNavigatorProcess;

/**
 * Created by IntelliJ IDEA.
 * @author diouf-a
 * Date: 20/05/11
 * Time: 11:05
 * To change this template use File | Settings | File Templates.
 */
public class AccessPropertiesEvent extends CairngormEvent {
  /**
   * Access permissions of a given process had changed.
   */
  public static const ACCESS_PERMISSIONS_CHANGED:String = "AccessPropertiesEvent_PermissionsChanged";
  /**
   * Selected process for access permissions had changed.
   */
  public static const PROCESS_CHANGED:String = "AccessPropertiesEvent_ProcessChanged";
  /**
   * List of processes administered by the current user should be fetched.
   */
  public static const FETCH_ADMIN_PROCESSES:String = "AccessPropertiesEvent_FetchAdminProcesses";

  private var _process:FileNavigatorProcess;

  private var _accessPermissions:ListCollectionView;

  public function AccessPropertiesEvent(type:String, process:FileNavigatorProcess = null, accessPermissions:ListCollectionView = null, bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, bubbles, cancelable);
    _process = process;
    if (accessPermissions != null) {
      _accessPermissions = new ArrayCollection();
      _accessPermissions.addAll(accessPermissions);
    }

  }

  public function get process():FileNavigatorProcess {
    return _process;
  }

  public function get accessPermissions():ListCollectionView {
    return _accessPermissions;
  }
}
}
