/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import mx.events.CollectionEvent;
import mx.events.CollectionEventKind;

/**
 * This class extends {@link CollectionEvent} to provide an event to dispatch after an collection.addAll.
 * As for now all classes implementing an addAll operation dispatch an collection change event for each added element.
 *
 * @author Loic Albertin
 */
public class CollectionAddAllEvent extends CollectionEvent {

  public static const COLLECTION_CHANGE_ADD_ALL:String = "collectionChangeAddAll";

  public function CollectionAddAllEvent(type:String, items:Array = null, bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, bubbles, cancelable, CollectionEventKind.ADD, -1, -1, items);
  }
}
}
