package org.ow2.orchestra.designer.view {
  import flash.events.MouseEvent;
  import flash.filters.GlowFilter;

  import mx.controls.Image;
  import mx.events.FlexEvent;
  import mx.states.State;

  [Style(name="glowColor", type="uint", format="Color")]

  public class GlowButton extends Image {

    private var glowFilter:GlowFilter;

    public function GlowButton() {
      super();
      this.glowFilter = new GlowFilter();
      this.glowFilter.blurX = 12;
      this.glowFilter.blurY = 9;
      this.glowFilter.alpha = 1;
      this.glowFilter.quality = 2;
      this.glowFilter.knockout = false;
      this.glowFilter.strength = 1;
      this.addEventListener(MouseEvent.MOUSE_OVER, handleMouseOver);
      this.addEventListener(MouseEvent.MOUSE_OUT, handleMouseOut);
      this.addEventListener(MouseEvent.MOUSE_DOWN, handleMouseDown);
      this.addEventListener(MouseEvent.MOUSE_UP, handleMouseUp);

      var defaultState:State = new State();
      defaultState.name = "default";
      var buttonDownState:State = new State();
      buttonDownState.name = "buttonDown";
      buttonDownState.addEventListener(FlexEvent.ENTER_STATE, enterButtonDownState);
      buttonDownState.addEventListener(FlexEvent.EXIT_STATE, exitButtonDownState);

      this.states = [defaultState, buttonDownState];
      this.currentState = "default";

      this.setStyle("glowColor", "#000000");


    }

    override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void {
      this.glowFilter.color = this.getStyle("glowColor");
      super.updateDisplayList(unscaledWidth, unscaledHeight);
    }

    private function handleMouseOver(event:MouseEvent):void {
      this.filters = [this.glowFilter];
    }

    private function handleMouseOut(event:MouseEvent):void {
      this.filters = null;
      this.currentState = "default";
    }

    private function handleMouseDown(event:MouseEvent):void {
      this.currentState = "buttonDown";
    }

    private function handleMouseUp(event:MouseEvent):void {
      this.currentState = "default";
    }

    private function enterButtonDownState(event:FlexEvent):void {
      this.x += 1;
      this.y += 1;
    }

    private function exitButtonDownState(event:FlexEvent):void {
      this.x -= 1;
      this.y -= 1;
    }
  }
}

